angular.module('starter.controllers')

//登录后的回调页
.controller('CallBackCtrl', ["$scope", "httpq", "AppConfig", "UserInfo", "$ionicPopup", "$location", "$state",function($scope, httpq, AppConfig, UserInfo, $ionicPopup, $location, $state) {
  user_token = $location.search().user_token;
  if (user_token) {
    httpq.post(
      AppConfig.host + "/api/user/getUserInfo", {
        "user_token": user_token,
        "account_id": AppConfig.account_id
      }
    ).then(function(data) {
      if (data.error_code === 0) {
        info = data.data;
        UserInfo.setToken(user_token);
        UserInfo.setAccountRole(info.account_role);
        UserInfo.setInfo(JSON.stringify(info));
        $location.path("/");
      } else {
        $ionicPopup.alert({
          title: '错误',
          template: '登录失败'
        });
      }
    });
  } else {
    $location.path("/");
  }
}])

//登录页
.controller('LoginCtrl', ["$scope","$ionicHistory" ,"$timeout" , "$interval","httpq","$sce", "AppConfig", "UserInfo", "$ionicPopup", "$location", "$state",function($scope,$ionicHistory ,$timeout , $interval,httpq,$sce, AppConfig, UserInfo, $ionicPopup, $location, $state) {
  var login_sign = hex_md5("'"+ new Date().getTime() +Math.random()+"'"+"ghdghdgrdsefgrs56gfr");
  $scope.login_url = $sce.trustAsResourceUrl(AppConfig.login_url+"?login_sign="+login_sign) ;
  //定时检查
 var timer = $interval(function(){
      httpq.post(
        AppConfig.host + "/passport/user/checkLogin", 
        {"login_sign": login_sign},true,true).then(function(data){
          // console.log(data);
          if (data.error_code === 0 ) {
                user_token = data.data;
                httpq.post(
                  AppConfig.host + "/api/user/getUserInfo", {
                    "user_token": user_token,
                    "account_id": AppConfig.account_id,
                  }
                ).then(function(data) {
                  if (data.error_code === 0) {
                    UserInfo.setToken(user_token);
                    UserInfo.setAccountRole(data.data.account_role);
                    UserInfo.setInfo(JSON.stringify(data.data));
                    $state.go("tab.home.toptab1");
                  } else {
                    $ionicPopup.alert({
                      title: '错误',
                      template: '登录失败'
                    }).then(function(){
                      $state.go("tab.home.toptab1");
                    })
                  }
                });
            $interval.cancel(timer);
            $timeout.cancel(timer2);

          };
        })

    }, 1000, 500) //1000毫秒执行一次，最多执行500次

 //超时
 var timer2 = $timeout(function(){
      $ionicPopup.alert({
        title: '错误',
        template: '登录超时'
      }).then(function(){
        $interval.cancel(timer);
        $state.go("tab.home.toptab1");
      })


    }, 500000) //500秒为超时 

  $scope.goback = function() {
    viewHistory = $ionicHistory.viewHistory();
    if (viewHistory.backView) {
      stateName = viewHistory.backView.stateName;
    } else {
      //如果不存在返回历史，则给它设置一个默认url
      stateName = "tab.home.toptab1";

    }
    $state.go(stateName);
    $interval.cancel(timer);
    $timeout.cancel(timer2);
    //$ionicHistory.goBack();//返回上一页(使用内置的函数实现)
  };

}])


//控制底部tab的隐藏
.controller('TabHideCtrl', ["$scope", "$rootScope", "$state",function($scope, $rootScope, $state) {
  $rootScope.$on('$ionicView.beforeEnter', function() {
    $rootScope.hideTabs = false;
    switch ($state.current.name) {
      case 'tab.home.toptab1':
        break;
      case 'tab.home.toptab2':
        break;
      case 'tab.home.toptab3':
        break;
      case 'tab.message':
        break;
      case 'tab.my':
        break;
      case 'tab.find':
        break;
      default:
        $rootScope.hideTabs = true;
    }
  });
}])

.controller("FindCtrl", ["$scope", "$ionicPopup", "$ionicModal" ,function($scope, $ionicPopup, $ionicModal) {
  $scope.openLink = function(tmpl_name) {
    $ionicModal.fromTemplateUrl("templates/find/" + tmpl_name + ".html", {
      scope: $scope,
      animation: "slide-in-up"
    }).then(function(modal) {
      $scope.modal = modal;
      $scope.modal.show();
    });

  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  //Cleanup the modal when we are done with it!
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on("modal.hidden", function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on("modal.removed", function() {
    // Execute action
  });


}])

//校园主页
.controller("HomeCtrl", ["$scope", "AppConfig" ,function($scope, AppConfig) {
  $scope.toptab1_cat_id = AppConfig.toptab1_cat_id;
  $scope.toptab2_cat_id = AppConfig.toptab2_cat_id;
  $scope.toptab3_cat_id = AppConfig.toptab3_cat_id;
  $scope.toptab1_cat_name = AppConfig.toptab1_cat_name;
  $scope.toptab2_cat_name = AppConfig.toptab2_cat_name;
  $scope.toptab3_cat_name = AppConfig.toptab3_cat_name;
}])

.controller("HomeToptab1Ctrl", ["$scope", "UserInfo", "$ionicHistory", "$rootScope", "Subjects", "AppConfig", "$ionicScrollDelegate", "$ionicLoading" ,function($scope, UserInfo, $ionicHistory, $rootScope, Subjects, AppConfig, $ionicScrollDelegate, $ionicLoading) {
  var toptab1_cat_id = AppConfig.toptab1_cat_id;
  var page = 1;
  var count = 20;
  Subjects.getListByCatId(toptab1_cat_id, page, count).then(function(data) {
    if (data.error_code === 0) {
      $scope.subjects = data.data;
    }
  });
  $scope.detail_html = "#/subject-detail/";

  $scope.doRefresh = function() {
    page = 1;
    Subjects.getListByCatId(toptab1_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        $scope.subjects = data.data;
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  }
  $scope.like = function(type, sub_id) {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    for (i in $scope.subjects) {
      if ($scope.subjects[i]['sub_id'] == sub_id) {
        if (type == 'like') {
          field = "like_count";
          current_state = $scope.subjects[i]['current_user_like'];
        };
        if (type == 'unlike') {
          field = "unlike_count";
          current_state = $scope.subjects[i]['current_user_unlike'];
        };
      };
    }
    if (current_state) {
      action = "sub";
    } else {
      action = "add";
    }
    Subjects.like(sub_id, field, action).then(function(data) {
      if (data.error_code === 0) {
        Subjects.update_subject_count(data.data);
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects[x]['like_count'] = data.data.like_count;
            $scope.subjects[x]['unlike_count'] = data.data.unlike_count;
            $scope.subjects[x]['current_user_like'] = data.data.current_user_like;
            $scope.subjects[x]['current_user_unlike'] = data.data.current_user_unlike;
            $scope.subjects[x]['comment_count'] = data.data.comment_count;
          }
        }
        //$scope.subjects = subjects;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      //该主题已被删除
      else if (data.error_code === 10307) {
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects.splice(x, 1);
          }
        }
      }
    });
  }
  $scope.load_more = function() {
    if ($scope.subjects && $scope.subjects.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };

    page = page + 1;
    Subjects.getListByCatId(toptab1_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        if (data.data.length > 0) {
          new_subjects = data.data;
          for (var i = 0; i < new_subjects.length; i++) {
            $scope.subjects.push(new_subjects[i]);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }

  //当用户从发布框页面发布完成后，将自动刷新主题列表
  //另外删除主题时也删除缓存中的主题
  $scope.$on('$stateChangeSuccess', function() {
    if ($rootScope.toptabReload == toptab1_cat_id) {
      $scope.doRefresh();
      $ionicScrollDelegate.scrollTop();
      $rootScope.toptabReload = false;
    }

    if ($rootScope.toptabDeleteSubject) {
      delete_sub_id = $rootScope.toptabDeleteSubject;
      for (i in $scope.subjects) {
        if ($scope.subjects[i]['sub_id'] == sub_id) {
          $scope.subjects[i] = [];
          $rootScope.toptabDeleteSubject = false;
        };
      }
    };
  });


}])

.controller("HomeToptab2Ctrl", ["$scope", "UserInfo", "$ionicHistory", "$rootScope", "Subjects", "AppConfig", "$ionicScrollDelegate", "$ionicLoading", function($scope, UserInfo, $ionicHistory, $rootScope, Subjects, AppConfig, $ionicScrollDelegate, $ionicLoading) {
  var toptab2_cat_id = AppConfig.toptab2_cat_id;
  var page = 1;
  var count = 20;
  Subjects.getListByCatId(toptab2_cat_id, page, count).then(function(data) {
    if (data.error_code === 0) {
      $scope.subjects = data.data;
    }
  });
  $scope.detail_html = "#/subject-detail/";

  $scope.doRefresh = function() {
    page = 1;
    Subjects.getListByCatId(toptab2_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        $scope.subjects = data.data;
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  }
  $scope.like = function(type, sub_id) {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    for (i in $scope.subjects) {
      if ($scope.subjects[i]['sub_id'] == sub_id) {
        if (type == 'like') {
          field = "like_count";
          current_state = $scope.subjects[i]['current_user_like'];
        };
        if (type == 'unlike') {
          field = "unlike_count";
          current_state = $scope.subjects[i]['current_user_unlike'];
        };
      };
    }
    if (current_state) {
      action = "sub";
    } else {
      action = "add";
    }
    Subjects.like(sub_id, field, action).then(function(data) {
      if (data.error_code === 0) {
        Subjects.update_subject_count(data.data);
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects[x]['like_count'] = data.data.like_count;
            $scope.subjects[x]['unlike_count'] = data.data.unlike_count;
            $scope.subjects[x]['current_user_like'] = data.data.current_user_like;
            $scope.subjects[x]['current_user_unlike'] = data.data.current_user_unlike;
            $scope.subjects[x]['comment_count'] = data.data.comment_count;
          }
        }
        //$scope.subjects = subjects;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      //该主题已被删除
      else if (data.error_code === 10307) {
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects.splice(x, 1);
          }
        }
      }
    });
  }
  $scope.load_more = function() {
    if ($scope.subjects && $scope.subjects.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };

    page = page + 1;
    Subjects.getListByCatId(toptab2_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        if (data.data.length > 0) {
          new_subjects = data.data;
          for (var i = 0; i < new_subjects.length; i++) {
            $scope.subjects.push(new_subjects[i]);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }

  //当用户从发布框页面发布完成后，将自动刷新主题列表
  $scope.$on('$stateChangeSuccess', function() {
    if ($rootScope.toptabReload == toptab2_cat_id) {
      $scope.doRefresh();
      $ionicScrollDelegate.scrollTop();
      $rootScope.toptabReload = false;
    }

    if ($rootScope.toptabDeleteSubject) {
      delete_sub_id = $rootScope.toptabDeleteSubject;
      for (i in $scope.subjects) {
        if ($scope.subjects[i]['sub_id'] == sub_id) {
          $scope.subjects[i] = [];
          $rootScope.toptabDeleteSubject = false;
        };
      }
    };
  });

}])

.controller("HomeToptab3Ctrl", ["$scope", "UserInfo", "$ionicHistory", "$rootScope", "Subjects", "AppConfig", "$ionicScrollDelegate", "$ionicLoading" ,function($scope, UserInfo, $ionicHistory, $rootScope, Subjects, AppConfig, $ionicScrollDelegate, $ionicLoading) {
  var toptab3_cat_id = AppConfig.toptab3_cat_id;
  var page = 1;
  var count = 20;
  Subjects.getListByCatId(toptab3_cat_id, page, count).then(function(data) {
    if (data.error_code === 0) {
      $scope.subjects = data.data;
    }
  });
  $scope.detail_html = "#/subject-detail/";

  $scope.doRefresh = function() {
    page = 1;
    Subjects.getListByCatId(toptab3_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        $scope.subjects = data.data;
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  }
  $scope.like = function(type, sub_id) {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    for (i in $scope.subjects) {
      if ($scope.subjects[i]['sub_id'] == sub_id) {
        if (type == 'like') {
          field = "like_count";
          current_state = $scope.subjects[i]['current_user_like'];
        };
        if (type == 'unlike') {
          field = "unlike_count";
          current_state = $scope.subjects[i]['current_user_unlike'];
        };
      };
    }
    if (current_state) {
      action = "sub";
    } else {
      action = "add";
    }
    Subjects.like(sub_id, field, action).then(function(data) {
      if (data.error_code === 0) {
        Subjects.update_subject_count(data.data);
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects[x]['like_count'] = data.data.like_count;
            $scope.subjects[x]['unlike_count'] = data.data.unlike_count;
            $scope.subjects[x]['current_user_like'] = data.data.current_user_like;
            $scope.subjects[x]['current_user_unlike'] = data.data.current_user_unlike;
            $scope.subjects[x]['comment_count'] = data.data.comment_count;
          }
        }
        //$scope.subjects = subjects;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      //该主题已被删除
      else if (data.error_code === 10307) {
        for (x in $scope.subjects) {
          if ($scope.subjects[x]['sub_id'] == sub_id) {
            $scope.subjects.splice(x, 1);
          }
        }
      }
    });
  }
  $scope.load_more = function() {
    if ($scope.subjects && $scope.subjects.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };

    page = page + 1;
    Subjects.getListByCatId(toptab3_cat_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        if (data.data.length > 0) {
          new_subjects = data.data;
          for (var i = 0; i < new_subjects.length; i++) {
            $scope.subjects.push(new_subjects[i]);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }

  //当用户从发布框页面发布完成后，将自动刷新主题列表
  $scope.$on('$stateChangeSuccess', function() {
    if ($rootScope.toptabReload == toptab3_cat_id) {
      $scope.doRefresh();
      $ionicScrollDelegate.scrollTop();
      $rootScope.toptabReload = false;
    }

    if ($rootScope.toptabDeleteSubject) {
      delete_sub_id = $rootScope.toptabDeleteSubject;
      for (i in $scope.subjects) {
        if ($scope.subjects[i]['sub_id'] == sub_id) {
          $scope.subjects[i] = [];
          $rootScope.toptabDeleteSubject = false;
        };
      }
    };

  });
}])

.controller("addButton", ["$scope", "UserInfo", "$ionicModal", "AppConfig" ,function($scope, UserInfo, $ionicModal, AppConfig) {
  $scope.toptab1_cat_id = AppConfig.toptab1_cat_id;
  $scope.toptab2_cat_id = AppConfig.toptab2_cat_id;
  $scope.toptab3_cat_id = AppConfig.toptab3_cat_id;
  $scope.toptab1_cat_name = AppConfig.toptab1_cat_name;
  $scope.toptab2_cat_name = AppConfig.toptab2_cat_name;
  $scope.toptab3_cat_name = AppConfig.toptab3_cat_name;
  $ionicModal.fromTemplateUrl("templates/subject/chose-catalog.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.add = function() {
    if (UserInfo.checkLogin()) {
      $scope.modal.show();
    };

  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  //Cleanup the modal when we are done with it!
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on("modal.hidden", function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on("modal.removed", function() {
    // Execute action
  });

}])

.controller("ManageCtrl", ["$scope",function($scope) {

}])

.controller("ManageSettingCtrl", ["$scope", "$ionicPopup" , function($scope, $ionicPopup) {
  $scope.showRatePopup = function() {
    $scope.data = {}

    // 自定义弹窗
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.wifi">',
      title: '请输入一个整数',
      subTitle: '',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>保存</b>',
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.wifi) {
            // 不允许用户关闭，除非输入 wifi 密码
            e.preventDefault();
          } else {
            return $scope.data.wifi;
          }
        }
      }, ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
    $timeout(function() {
      myPopup.close(); // 3秒后关闭弹窗
    }, 3000);
  };
  $scope.showUserPopup = function() {
    $scope.data = {}

    // 自定义弹窗
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.wifi">',
      title: '请输入一个整数',
      subTitle: '',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>保存</b>',
        type: 'button-positive',
        onTap: function(e) {
          if (!$scope.data.wifi) {
            // 不允许用户关闭，除非输入 wifi 密码
            e.preventDefault();
          } else {
            return $scope.data.wifi;
          }
        }
      }, ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
    $timeout(function() {
      myPopup.close(); // 3秒后关闭弹窗
    }, 3000);
  };
}])

.controller('ManageKeywordCtrl', ["$scope", "Keyword", "$ionicPopup" ,function($scope, Keyword, $ionicPopup) {
  $scope.data = {};
  $scope.keywords = {};
  $scope.showAddPopup = function() {

    // 自定义弹窗
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.keyword">',
      title: '请输入要过滤的关键字',
      subTitle: '',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>保存</b>',
        type: 'button-positive',
        onTap: function(e) {
          if ($scope.data.keyword) {
            Keyword.add($scope.data.keyword).then(function(data) {
              if (data.error_code === 0) {
                $scope.data.keyword = '';
                $scope.getList();
              };
            });
          } else {
            e.preventDefault();
          }
        }
      }, ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
  };

  $scope.getList = function() {
    Keyword.getList().then(function(data) {
      if (data.error_code === 0) {
        $scope.keywords = data.data;
      };
    });
  }
  $scope.getList();
  $scope.delete = function(id) {
    var confirmPopup = $ionicPopup.confirm({
      title: '温馨提示',
      template: '你确定要删除此关键字吗',
      cancelText: "取消",
      okText: "是的"
    });
    confirmPopup.then(function(res) {
      if (res) {
        if (id) {
          Keyword.deleteKeyword(id).then(function(data) {
            if (data.error_code === 0) {
              $scope.getList();
            };
          });
        }
      }
    });



  }
}])

.controller('ManageDeleterCtrl',["$scope", "Deleter", "$ionicPopup", function($scope, Deleter, $ionicPopup) {
  $scope.data = {};
  $scope.keywords = {};
  $scope.showAddPopup = function() {

    // 自定义弹窗
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.input_name">',
      title: '请输入对方的用户昵称',
      subTitle: '',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>保存</b>',
        type: 'button-positive',
        onTap: function(e) {
          if ($scope.data.input_name) {
            Deleter.add($scope.data.input_name).then(function(data) {
              if (data.error_code === 0) {
                $ionicPopup.alert({
                  title: "提示",
                  template: "添加成功！对方需要重新退出并登录才能使用删除功能"
                }).then(function() {
                  $scope.data.input_name = '';
                  $scope.getList();
                });

              } else {
                $ionicPopup.alert({
                  title: "提示",
                  template: data.error_message
                });
              };
            });

          } else {
            e.preventDefault();
          }
        }
      }, ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
  };

  $scope.getList = function() {
    Deleter.getList().then(function(data) {
      if (data.error_code === 0) {
        $scope.deleters = data.data;
      };
    });
  }
  $scope.getList();
  $scope.delete = function(id) {
    var confirmPopup = $ionicPopup.confirm({
      title: '温馨提示',
      template: '你确定要取消此人删除者身份吗？',
      cancelText: "取消",
      okText: "是的"
    });
    confirmPopup.then(function(res) {
      if (res) {
        if (id) {
          Deleter.deleteUser(id).then(function(data) {
            if (data.error_code === 0) {
              $scope.getList();
            };
          });
        }
      }
    });



  }
}])

.controller('ManageAdminCtrl', ["$scope", "ManageAdmin", "$ionicPopup",function($scope, ManageAdmin, $ionicPopup) {
  $scope.data = {};
  $scope.keywords = {};
  $scope.showAddPopup = function() {

    // 自定义弹窗
    var myPopup = $ionicPopup.show({
      template: '<input type="text" ng-model="data.input_name">',
      title: '请输入对方的用户昵称',
      subTitle: '',
      scope: $scope,
      buttons: [{
        text: '取消'
      }, {
        text: '<b>保存</b>',
        type: 'button-positive',
        onTap: function(e) {
          if ($scope.data.input_name) {
            ManageAdmin.add($scope.data.input_name).then(function(data) {
              if (data.error_code === 0) {
                $ionicPopup.alert({
                  title: "提示",
                  template: "添加成功！对方需要重新退出并登录才能使用管理功能"
                }).then(function() {
                  $scope.data.input_name = '';
                  $scope.getList();
                });
              } else {
                $ionicPopup.alert({
                  title: "提示",
                  template: data.error_message
                });
              };
            });

          } else {
            e.preventDefault();
          }
        }
      }, ]
    });
    myPopup.then(function(res) {
      console.log('Tapped!', res);
    });
  };

  $scope.getList = function() {
    ManageAdmin.getList().then(function(data) {
      if (data.error_code === 0) {
        $scope.admins = data.data;
      };
    });
  }
  $scope.getList();
  $scope.delete = function(id) {
    var confirmPopup = $ionicPopup.confirm({
      title: '温馨提示',
      template: '你确定要取消此人管理员身份吗？',
      cancelText: "取消",
      okText: "是的"
    });
    confirmPopup.then(function(res) {
      if (res) {
        if (id) {
          ManageAdmin.deleteAdmin(id).then(function(data) {
            if (data.error_code === 0) {
              $scope.getList();
            };
          });
        }
      }
    });



  }
}])

.controller('ManageAuthCtrl', ["$scope","httpq","UserInfo", "AppConfig", "$ionicPopup",function($scope,httpq,UserInfo, AppConfig, $ionicPopup) {
    httpq.post(
      AppConfig.host + "/api/account/weiboList", {
        "account_id": AppConfig.account_id,
      }).then(function(data) {
      if (data.error_code === 0 && data.data) {
        $scope.auths = data.data;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
    });
}])

.controller('ManageAuthDetailCtrl', ["$sce","$ionicHistory","$state", "$scope","httpq", "AppConfig", "$ionicPopup",function($sce ,$ionicHistory,$state,$scope,httpq, AppConfig, $ionicPopup) {
  $scope.login_url = $sce.trustAsResourceUrl('http://yard.star7th.com/server/index.php/passport/user/authLogin');
  $scope.goback = function() {
    viewHistory = $ionicHistory.viewHistory();
    if (viewHistory.backView) {
      stateName = viewHistory.backView.stateName;
    } else {
      //如果不存在返回历史，则给它设置一个默认url
      stateName = "tab.home.toptab1";

    }
    $state.go(stateName);
    //$ionicHistory.goBack();//返回上一页(使用内置的函数实现)
  };
}])

.controller("MessageCtrl", ["$scope", "UserInfo", "Chats" ,function($scope, UserInfo, Chats) {
  if (!UserInfo.checkLogin()) {
    return false;
  }
  $scope.chats = Chats.all();
}])

.controller('MessageDetailCtrl', ["$scope", "Chats", "$stateParams", "$ionicScrollDelegate", "$rootScope", function($scope, Chats, $stateParams, $ionicScrollDelegate, $rootScope) {
  $scope.chat = Chats.get($stateParams.chatId);
  var messageOptions = [{
    content: '<p>Wow, this is really something huh?</p>'
  }, {
    content: '<p>Yea, it\'s pretty sweet</p>'
  }, {
    content: '<p>I think I like Ionic more than I like ice cream!</p>'
  }, {
    content: '<p>Gee wiz, this is something special.</p>'
  }, {
    content: '<img src="http://tp4.sinaimg.cn/1709381783/180/5653400725/1" alt=""/>'
  }, {
    content: '<p>Is this magic?</p>'
  }, {
    content: '<p>Am I dreaming?</p>'
  }, {
    content: '<img src="http://tp4.sinaimg.cn/1709381783/180/5653400725/1" alt=""/>'
  }, {
    content: '<p>Am I dreaming?</p>'
  }, {
    content: '<p>Yea, it\'s pretty sweet</p>'
  }, {
    content: '<p>I think I like Ionic more than I like ice cream!</p>'
  }, ];

  var messageIter = 0;
  $scope.messages = messageOptions.slice(0, messageOptions.length);

  $scope.add = function() {
    var nextMessage = messageOptions[messageIter++ % messageOptions.length];
    $scope.messages.push(angular.extend({}, nextMessage));

    // Update the scroll area and tell the frosted glass to redraw itself
    // $ionicFrostedDelegate.update();
    $ionicScrollDelegate.scrollBottom(true);
  };
}])

.controller("MyCtrl", ["$scope", "UserInfo" , function($scope, UserInfo) {
  if (!UserInfo.checkLogin()) {
    $scope.hide = true;
    return false;
  }
  $scope.user_info = UserInfo.getInfo();
  $scope.show_mangage = false;
  account_role = UserInfo.getAccountRole();
  if (account_role == "admin" || account_role == "creator") {
    $scope.show_mangage = true;
  };
  if (!$scope.user_info.thumb_avatar) {
    $scope.user_info.thumb_avatar = 'img/default_avatar.jpg'
  };
}])

.controller("MyProfileCtrl", ["$scope", "httpq", "$ionicLoading", "Subjects", "Upload", "AppConfig", "$ionicModal", "UserInfo", function($scope, httpq, $ionicLoading, Subjects, Upload, AppConfig, $ionicModal, UserInfo) {
  user_info = UserInfo.getInfo();
  user_info.wechat = user_info.wechat.length > 0 ? user_info.wechat : "未填写";
  $scope.user_info = user_info;
  if (!$scope.user_info.thumb_avatar) {
    $scope.user_info.thumb_avatar = 'img/default_avatar.jpg'
  };

  $scope.form = {};
  $scope.form.name = user_info.name;
  $scope.form.introduction = user_info.introduction;
  $scope.form.school_name = user_info.school_name;
  $scope.form.college_name = user_info.college_name;
  $scope.form.school_year = user_info.school_year;
  $scope.form.wechat = user_info.wechat;

  $ionicModal.fromTemplateUrl("templates/my/edit-profile.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.edit = function() {
    $scope.modal.show();
  }
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  //Cleanup the modal when we are done with it!
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
  });

  $scope.save = function() {
    httpq.post(
      AppConfig.host + "/api/user/updateUserInfo", {
        "name": $scope.form.name,
        "introduction": $scope.form.introduction,
        "school_name": $scope.form.school_name,
        "college_name": $scope.form.college_name,
        "school_year": $scope.form.school_year,
        "wechat": $scope.form.wechat,
      }).then(function(data) {
      if (data.error_code === 0 && data.data) {
        user_info = data.data;
        $scope.user_info = user_info;
        UserInfo.setInfo(user_info);
        $scope.closeModal();
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
    });
  }

  //上传头像
  $scope.upload = function(file) {
    if (!file) {
      return false
    };
    //alert("开始上传文件！！");
    $ionicLoading.show({
      template: "正在上传，请稍后..."
    });
    //获取七牛上传token
    Subjects.getQiniuToken().then(function(data) {
      if (data.error_code === 0) {
        var upload_token = data.data.upload_token;
        var qiniu_domain = data.data.qiniu_domain;
        var key = Math.random() + Date.parse(new Date()) + ".jpg"
        Upload.upload({
          url: 'http://upload.qiniu.com/',
          data: {
            file: file,
            'token': upload_token,
            "key": key
          }
        }).then(function(resp) {
          //console.log('Success ' + resp.config.data.file.name + 'uploaded. Response: ' + resp.data);
          if (resp.data.key) {
            $ionicLoading.hide();
            avatar = 'http://' + qiniu_domain + "/" + resp.data.key;
            thumb_avatar = avatar + "?imageView/1/w/150/h/150";
            //更新头像链接
            httpq.post(
              AppConfig.host + "/api/user/updateUserInfo", {
                "avatar": avatar,
                "thumb_avatar": thumb_avatar,
              }).then(function(data) {
              if (data.error_code === 0 && data.data) {
                user_info = data.data;
                $scope.user_info = user_info;
                UserInfo.setInfo(user_info);
              } else if (data.error_code === 10103) {
                UserInfo.reLogin();
              }
            });
          };
        }, function(resp) {
          console.log('Error status: ' + resp.status);
        }, function(evt) {
          var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
          $ionicLoading.show({
            template: "正在上传图片，请稍后..." + progressPercentage + '% '
          });
        });
      };
    });


  };

}])

.controller("MyFollowSubjectCtrl", ["$scope", "UserInfo", "$ionicHistory", "Subjects", "AppConfig", "$ionicScrollDelegate", "$ionicLoading", function($scope, UserInfo, $ionicHistory, Subjects, AppConfig, $ionicScrollDelegate, $ionicLoading) {
  $scope.detail_html = "#/tab/my-follow-subject-detail/";
  var page = 1;
  var count = 20;
  $scope.subjects = [];
  Subjects.getMyFollowList(page, count).then(function(data) {
    if (data.error_code === 0 && data.data.length > 0) {
      for (i in data.data) {
        $scope.subjects.push(data.data[i]['subject']);
      }
    } else if (data.error_code === 10103) {
      UserInfo.reLogin();
    }
  });
  $scope.detail_html = "#/subject-detail/";

  $scope.doRefresh = function() {
    page = 1;
    Subjects.getMyFollowList(page, count).then(function(data) {
      if (data.error_code === 0 && data.data.length > 0) {
        $scope.subjects = [];
        for (i in data.data) {
          $scope.subjects.push(data.data[i]['subject']);
        }
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  }
  $scope.load_more = function() {
    if ($scope.subjects && $scope.subjects.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };

    page = page + 1;
    Subjects.getMyFollowList(page, count).then(function(data) {
      if (data.error_code === 0 && data.data.length > 0) {
        if (data.data.length > 0) {
          new_subjects = data.data;
          for (var i = 0; i < new_subjects.length; i++) {
            $scope.subjects.push(new_subjects[i]['subject']);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }
}])

.controller("MySubjectCtrl", ["$scope", "UserInfo", "$ionicHistory", "Subjects", "AppConfig", "$ionicScrollDelegate", "$ionicLoading",function($scope, UserInfo, $ionicHistory, Subjects, AppConfig, $ionicScrollDelegate, $ionicLoading) {
  $scope.detail_html = "#/tab/my-subject-detail/";
  var page = 1;
  var count = 20;
  Subjects.getMyList(page, count).then(function(data) {
    if (data.error_code === 0) {
      $scope.subjects = data.data;
    } else if (data.error_code === 10103) {
      UserInfo.reLogin();
    }
  });
  $scope.detail_html = "#/subject-detail/";

  $scope.doRefresh = function() {
    page = 1;
    Subjects.getMyList(page, count).then(function(data) {
      if (data.error_code === 0) {
        $scope.subjects = data.data;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
      $scope.$broadcast("scroll.refreshComplete");
    });
  }
  $scope.load_more = function() {
    if ($scope.subjects && $scope.subjects.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };

    page = page + 1;
    Subjects.getMyList(page, count).then(function(data) {
      if (data.error_code === 0) {
        if (data.data.length > 0) {
          new_subjects = data.data;
          for (var i = 0; i < new_subjects.length; i++) {
            $scope.subjects.push(new_subjects[i]);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }
}])

.controller("SinaDetailCtrl", ["$scope", "$sce", "UserInfo", "$stateParams",function($scope, $sce, UserInfo, $stateParams) {
  sina_uid = $stateParams.sina_uid;
  sina_url = "http://m.weibo.cn/" + sina_uid;
  $scope.sina_url = $sce.trustAsResourceUrl(sina_url);
  console.log($scope.sina_url)
}])

.controller("MySettingCtrl", ["$scope", "$sce", "$ionicPopup", "UserInfo", "$stateParams",function($scope, $sce, $ionicPopup, UserInfo, $stateParams) {
  UserInfo.checkLogin();
  $scope.exitLogin = function() {

    if (UserInfo.checkLogin()) {
      var confirmPopup = $ionicPopup.confirm({
        title: '温馨提示',
        template: '你确定要退出登录吗？',
        cancelText: "取消",
        okText: "是的"
      });
      confirmPopup.then(function(res) {
        if (res) {
          UserInfo.exitLogin();
        }
      });
    };
  }


}])

.controller("MyFeedbackCtrl", ["$scope", "httpq","AppConfig","$ionicPopup", "UserInfo","$stateParams",function($scope, httpq,AppConfig,$ionicPopup, UserInfo, $stateParams) {
  $scope.form = [];
  $scope.submit = function(){
    var device = getDevice();
    httpq.post(
      AppConfig.host + "/api/app/feedback", {
        "version": AppConfig.version,
        "device": device,
        "content":$scope.form.content,
        "email":$scope.form.email
      },true
    ).then(function(data) {
        $ionicPopup.alert({
          title: "提示",
          template: "你的反馈已成功提交"
        });
        $scope.form = [];
      })
    }
  

}])


.controller("SubjectListCtrl", ["$scope", "Subjects","$ionicModal", "Upload","UserInfo","$ionicActionSheet","$ionicPopup","$ionicLoading","httpq","AppConfig",function($scope, Subjects, $ionicModal, Upload,UserInfo,$ionicActionSheet,$ionicPopup,$ionicLoading,httpq,AppConfig ) {
    
    $scope.ShowOptions = function(sub_id,subjects) {
      // Show the action sheet
      buttons = [
      {
        text: "关注主题",
      },
      {
        text: "我要屏蔽",
      },
      {
        text: "举报投诉",
      },
       ];
      account_role = UserInfo.getAccountRole();
      if (account_role == "deleter" || account_role == "admin" || account_role == "creator") {
        buttons.push({
          text: " 删除主题"
        });
      };
      if (account_role == "admin" || account_role == "creator") {
        buttons.push({
          text: " 拉黑此人"
        });
      };
      if (account_role == "admin" || account_role == "creator") {
        buttons.push({
          text: " 查看匿名"
        });
      };
      var hideSheet = $ionicActionSheet.show({
        titleText: "操作",
        buttons: buttons,
        buttonClicked: function(index) {
          switch (index) {
            case 0:
              $scope.follow(sub_id);
              break;
            case 1:
              $scope.block(sub_id,subjects);
              break;

            case 2:
              $scope.complaints(sub_id);
              break;

            case 3:
              $scope.delete(sub_id,subjects);
              break;
            case 4:
              $scope.blacklist(sub_id);
              break;
            case 5:
              $scope.showAuthor(sub_id);
              break;
          }
          return true;
        },
        cancelText: "取消",
        cancel: function() {
          // add cancel code..
        }
      });
    };
    $scope.complaints = function(sub_id){
          httpq.post(
            AppConfig.host + "/api/app/complaints", {
              "account_id": AppConfig.account_id,
              "sub_id": sub_id,
            }
          ).then(function(data) {
              $ionicPopup.alert({
                title: '提示',
                template: '系统已经接收到了你的举报，我们将尽快处理'
              })
          });
    }

    //屏蔽主题
    $scope.block = function(sub_id,subjects) {
        if (!UserInfo.checkLogin()) {
          return false;
        }
        Subjects.block(sub_id).then(function(data) {
          if (data.error_code === 0) {
          //从主题列表数据中删除
          for (x in subjects) {
            if (subjects[x]['sub_id'] == sub_id) {
              subjects.splice(x, 1);
            }
          }
          } else if (data.error_code === 10103) {
            UserInfo.reLogin();
          }
        });
      }

    //删除主题
    $scope.delete = function(sub_id,subjects) {
        if (!UserInfo.checkLogin()) {
          return false;
        }
        Subjects.delete(sub_id).then(function(data) {
          if (data.error_code === 0) {
            $ionicLoading.show({
              template: "删除成功！",
              noBackdrop: true,
              duration: 500
            });
          //从主题列表数据中删除
          for (x in subjects) {
            if (subjects[x]['sub_id'] == sub_id) {
              subjects.splice(x, 1);
            }
          }
          } else if (data.error_code === 10103) {
            UserInfo.reLogin();
          }
        });
      }
      //关注主题
    $scope.follow = function(sub_id) {
      if (!UserInfo.checkLogin()) {
        return false;
      }
      Subjects.follow(sub_id).then(function(data) {
        if (data.error_code === 0) {
          $ionicLoading.show({
            template: "关注成功！",
            noBackdrop: true,
            duration: 500
          });
        } else if (data.error_code === 10103) {
          UserInfo.reLogin();
        }
      });
    }

    //拉黑主题的发布者
    $scope.blacklist = function(sub_id) {
      if (!UserInfo.checkLogin()) {
        return false;
      }
      Subjects.blacklist(sub_id).then(function(data) {
        if (data.error_code === 0) {
          $ionicLoading.show({
            template: "成功拉进黑名单30天",
            noBackdrop: true,
            duration: 1500
          });
        } else if (data.error_code === 10103) {
          UserInfo.reLogin();
        }
      });
    }

    //查看主题的发布者
    $scope.showAuthor = function(sub_id) {
      if (!UserInfo.checkLogin()) {
        return false;
      }
      $ionicPopup.alert({
        title: '温馨提示',
        template: '查看匿名功能只能查询用户所绑定的新浪微博昵称和用户自行注册时填写的手机号（由于微信不开放用户资料，故无法查询通过微信发布的用户微信号）',
        okText: "确认"
      }).then(function() {
        Subjects.showAuthor(sub_id).then(function(data) {
          if (data.error_code === 0) {
            var result = "查询结果如下：<br>" + "&nbsp;&nbsp;手机号：" + data.data.mobile + "<br>&nbsp;&nbsp;新浪微博：" + data.data.sina_name;
            $ionicPopup.alert({
              title: '温馨提示',
              template: result,
              okText: "确认"
            });
          } else if (data.error_code === 10103) {
            UserInfo.reLogin();
          }
        });
      });


    }
}])

.controller("SubjectDetailCtrl", ["$scope","httpq","AppConfig", "UserInfo", "$rootScope","$ionicLoading", "$ionicScrollDelegate", "$stateParams", "$state", "$ionicModal", "$ionicHistory", "$ionicActionSheet", "$ionicPopup", "Subjects",function($scope,httpq,AppConfig, UserInfo, $rootScope, $ionicLoading, $ionicScrollDelegate, $stateParams, $state, $ionicModal, $ionicHistory, $ionicActionSheet, $ionicPopup, Subjects) {
  sub_id = $stateParams.sub_id;
  $scope.form = [];
  $scope.comments = [];
  var reply_com_id = 0;
  var page = 1;
  var count = 20;
  $scope.getSubject = function() {
    $scope.subject = Subjects.getFromCache(sub_id);
    if (!$scope.subject) {
      Subjects.get(sub_id).then(function(data) {
        if (data.error_code === 0) {
          $scope.subject = data.data;
        }
      })
    };
  }

  $scope.getSubject(); //初始化获取主题详情

  $scope.getCommentList = function(page, count) {
    Subjects.getCommentList(sub_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        $scope.comments = data.data;
        for(x in $scope.comments){
          if (!$scope.comments[x].thumb_avatar) {
            $scope.comments[x].avatar = 'img/default_avatar.jpg';
            $scope.comments[x].thumb_avatar = 'img/default_avatar.jpg';
          };
        }
        $ionicScrollDelegate.scrollTop(page, count);
      }
    })
  }

  $scope.getCommentList(page, count); //初始化获取评论列表



  $ionicModal.fromTemplateUrl("templates/subject/input-comment.html", {
    scope: $scope,
    animation: "slide-in-up"
  }).then(function(modal) {
    $scope.modal = modal;
  });
  $scope.input_comment = function() {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    $scope.modal.show();
  };
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  //Cleanup the modal when we are done with it!
  $scope.$on("$destroy", function() {
    $scope.modal.remove();
  });

  $scope.reply_comment = function(com_id, name) {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    if (com_id) {
      reply_com_id = com_id;
      $scope.form.text = '回复@' + name + ' : ';
    }
    $scope.modal.show();
  }

  $scope.goback = function() {
    viewHistory = $ionicHistory.viewHistory();
    if (viewHistory.backView) {
      stateName = viewHistory.backView.stateName;
    } else {
      //如果不存在返回历史，则给它设置一个默认url
      stateName = "tab.home.toptab1";

    }
    $state.go(stateName);
    //$ionicHistory.goBack();//返回上一页(使用内置的函数实现)
  };




  $scope.like = function(type, sub_id) {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    if (type == 'like') {
      field = "like_count";
      current_state = $scope.subject['current_user_like'];
    };
    if (type == 'unlike') {
      field = "unlike_count";
      current_state = $scope.subject['current_user_unlike'];
    };
    if (current_state) {
      action = "sub";
    } else {
      action = "add";
    }
    Subjects.like(sub_id, field, action).then(function(data) {
      if (data.error_code === 0) {
        Subjects.update_subject_count(data.data);
        $scope.subject['like_count'] = data.data.like_count;
        $scope.subject['unlike_count'] = data.data.unlike_count;
        $scope.subject['current_user_like'] = data.data.current_user_like;
        $scope.subject['current_user_unlike'] = data.data.current_user_unlike;
        $scope.subject['comment_count'] = data.data.comment_count;
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      }
    });
  }

  $scope.submit_comment = function() {
    if (!UserInfo.checkLogin()) {
      return false;
    }
    if ($scope.form.text) {
      Subjects.send_comment(sub_id, reply_com_id, $scope.form.text).then(function(data) {
        if (data.error_code === 0) {
          $scope.form.text = '';
          //重新获取评论列表获取主题详情
          $scope.getSubject();
          //重新获取评论列表
          page = 1;
          $scope.getCommentList(page, count);
          $scope.closeModal();
        } else {
          $ionicPopup.alert({
            title: "提示",
            template: data.error_message
          });
        }


      })
    } else {
      alert("请输入内容");
    }
  };

  //评论滚动刷新
  $scope.load_more = function() {
    if ($scope.comments.length < 4) {
      $scope.$broadcast("scroll.infiniteScrollComplete");
      return false;
    };
    page = page + 1;
    Subjects.getCommentList(sub_id, page, count).then(function(data) {
      if (data.error_code === 0) {
        if (data.data.length > 0) {
          new_comments = data.data;
          for (var i = 0; i < new_comments.length; i++) {
            $scope.comments.push(new_comments[i]);
          }
        } else {
          $ionicLoading.show({
            template: "没有更多啦！",
            noBackdrop: true,
            duration: 500
          });
          $ionicScrollDelegate.scrollBy(0, -50);
        }
      }
      $scope.$broadcast("scroll.infiniteScrollComplete");
    });
  }

  //点击图片放大
  $scope.shouBigImage = function(Url) { //传递一个参数（图片的URl）
    $scope.BigImageUrl = Url; //$scope定义一个变量Url，这里会在大图出现后再次点击隐藏大图使用
    $scope.bigImage = true; //显示大图
  };

  $scope.hideBigImage = function() {
    $scope.bigImage = false;
  }

}])

.controller("AddSubjectCtrl", ["$scope","$interval", "httpq","$location" , "AppConfig","$ionicPopup", "UserInfo", "Subjects", "$ionicLoading", "$rootScope", "$stateParams", "Upload", "$ionicHistory","$state",function($scope,$interval, httpq,$location , AppConfig,$ionicPopup, UserInfo, Subjects, $ionicLoading, $rootScope, $stateParams, Upload, $ionicHistory, $state) {
  $scope.form = [];
  $scope.img_local_src = '';
  //判断是否是微信浏览器
  var ua = navigator.userAgent.toLowerCase();
  if(ua.match(/MicroMessenger/i)=="micromessenger") {
    $scope.isWeixin = 1 ;
    //加载配置
    httpq.post(
      AppConfig.host + "/api/weixin/weixinConfig", {
        "account_id": AppConfig.account_id,
        "jsurl":encodeURIComponent($location.absUrl())
      },true
    ).then(function(data) {
      if (data.error_code === 0) {
            wx.config({
              debug: false,
              appId: data.data.appId,
              timestamp: data.data.timestamp,
              nonceStr: data.data.nonceStr,
              signature: data.data.signature,
              jsApiList: [
                // 所有要调用的 API 都要加到这个列表中
                "chooseImage","uploadImage",
              ]
            });
      }
    });

  }else {
    $scope.isWeixin = 0 ;
  }

  $interval(function(){
          $scope.img_local_src = $scope.img_local_src;
      }, 1000, 1); //1000毫秒执行一次，一共执行1次

  $scope.submit = function() {
    if ($scope.form.file) {
      $scope.qiniuUpload($scope.form.file);
    }
    else if($scope.img_local_src){
      $scope.weixinUpload($scope.img_local_src);
    }
     else {
      $scope.send();
    }
  };

  $scope.send = function() {
    cat_id = $stateParams.cat_id;
    Subjects.send(cat_id, $scope.form.text, $scope.form.pic_url).then(function(data) {
      if (data.error_code === 0) {
        $scope.form = [];
        $scope.img_local_src = '';
        $rootScope.toptabReload = cat_id;
        $scope.goback();
      } else if (data.error_code === 10103) {
        UserInfo.reLogin();
      } else {
        $ionicPopup.alert({
          title: "提示",
          template: data.error_message
        });
      }
    })

  };

  // upload on file select or drop
  $scope.qiniuUpload = function(file) {
    if ($scope.form.pic_url) {
      $scope.send();
      return false;
    };
    //alert("开始上传文件！！");
    $ionicLoading.show({
      template: "正在上传图片，请稍后..."
    });
    //获取七牛上传token
    Subjects.getQiniuToken().then(function(data) {
      if (data.error_code === 0) {
        var upload_token = data.data.upload_token;
        var qiniu_domain = data.data.qiniu_domain;
        var key = Math.random() + Date.parse(new Date()) + ".jpg"
        Upload.upload({
          url: 'http://upload.qiniu.com/',
          data: {
            file: file,
            'token': upload_token,
            "key": key
          }
        }).then(function(resp) {
          //console.log('Success ' + resp.config.data.file.name + 'uploaded. Response: ' + resp.data);
          if (resp.data.key) {
            $ionicLoading.hide();
            $scope.form.pic_url = 'http://' + qiniu_domain + "/" + resp.data.key;
            $scope.send();
            //console.log(pic_url);
          };
        }, function(resp) {
          console.log('Error status: ' + resp.status);
        }, function(evt) {
          var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
          console.log('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
          $ionicLoading.show({
            template: "正在上传图片，请稍后..." + progressPercentage + '% '
          });
        });
      };
    });
  }

  $scope.weixinUpload = function(localId){
        wx.uploadImage({
            localId: localId, // 需要上传的图片的本地ID，由chooseImage接口获得
            isShowProgressTips: 1, // 默认为1，显示进度提示
            success: function (res) {
               console.log(res)   
                var serverId = res.serverId; // 返回图片的服务器端ID
                httpq.post(
                  AppConfig.host + "/api/weixin/savePicToQiniu", {
                    "account_id": AppConfig.account_id,
                    "media_id":serverId
                  },true
                ).then(function(data) {
                  if (data.error_code === 0) {
                      $scope.form.pic_url = data.data.url;
                      $scope.send();
                      return ;
                  }
                });
            }
        });
  }

  $scope.weixinChooseImage = function(){
      $scope.img_local_src = '';
      //console.log("开始选择图片")
      wx.chooseImage({
          count: 1, // 默认9
          sizeType: ['original', 'compressed'], // 可以指定是原图还是压缩图，默认二者都有
          sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
          success: function (res) {
              var localIds = res.localIds; // 返回选定照片的本地ID列表，localId可以作为img标签的src属性显示图片
              $scope.img_local_src = localIds[0];
              //console.log("执行回调")
              //console.log($scope.img_local_src)
              
          }
      });
      //微信添加图片后回调时，虽然数据更新了，似乎当前页面不会更新，要重新刷新才能看到新变化。
      //所以设置定时循环任务让当前页面更新
       var timer = $interval(function(){
              //console.log("doing task");
              $scope.img_local_src = $scope.img_local_src;
          }, 1500, 60); //2000毫秒执行一次，一共执行60次
  }

  $scope.goback = function() {
    viewHistory = $ionicHistory.viewHistory();
    if (viewHistory.backView) {
      stateName = viewHistory.backView.stateName;
    } else {
      //如果不存在返回历史，则给它设置一个默认url
      stateName = "tab.home.toptab1";

    }
    $state.go(stateName);
    //$ionicHistory.goBack();//返回上一页(使用内置的函数实现)
  };

}])